const checkLogin = require('letsnet-graphed').check
var gFunctionAuthenticator = require('letsnet-graphed').functionAuth

module.exports = function(defaults) {

    var model = {}

    model.loginCheck = function(req, res, next) {
        if(req.session.gLogin == null || req.session.gLogin === undefined) res.redirect('/Login')
        else {
            checkLogin({appid: defaults.gAppID}).check({fingerprint: req.session.gLogin.fingerprint, logged_user: req.session.gLogin.logged_user, location: req.session.gLogin.location}, function(error, data) {
                if(error || !data.document.logged_in){
                    req.session.redirectURL = req._parsedOriginalUrl.path
                    res.redirect('/Login')
                }
                else next()
            })
        }
    }

    model.loginCheckJSON = function(req, res, next) {
        if(req.session.gLogin == null || req.session.gLogin === undefined) res.status(200).send({error: true, lCode: '-E1', msg: 'Nincs bejelentkezve!', type:'session-error', func: '@loginCheck'})
        else {
            checkLogin({appid: defaults.gAppID}).check({fingerprint: req.session.gLogin.fingerprint, logged_user: req.session.gLogin.logged_user, location: req.session.gLogin.location}, (error, data) => {
                if(error || !data.document.logged_in){
                    req.session.redirectURL = req._parsedOriginalUrl.path
                    res.status(200).send({func: data.func, lCode: "-E1", msg: "Nincs bejelentkezve!", type: "error"})
                }
                else next()
            })
        }
    }

    model.loggedInCheck = function(req, res, next) {
        if(req.session.gLogin == null || req.session.gLogin === undefined) next()
        else {
            checkLogin({appid: defaults.gAppID}).check({fingerprint: req.session.gLogin.fingerprint, logged_user: req.session.gLogin.logged_user, location: req.session.gLogin.location}, (error, data) => {
                if(!error){
                    if(data.document.logged_in){
                        let URL = req.session.redirectURL || '/'
                        delete req.session.redirectURL
                        res.redirect(URL)
                    } else next()
                }
                else {
                    delete req.session.gLogin.fingerprint
                    delete req.session.gLogin.logged_user
                    delete req.session.gLogin
                    next()
                }
            })
        }
    }

    model.authenticateFunction = (req, res, next) => {
        if(req.headers.authorization === undefined) res.send({lCode: '-E1', msg: 'Nincs APIKEY', type:'authentication-error', func: '@authenticateFunction'})
        gFunctionAuthenticator({appid: defaults.gAppID}).authenticateFunction({function: `@${req.params.func}`, adminclass: req.headers.authorization.slice(7)}, function(error, document) {
            if(error) res.send(document)
            else next()
        })
    }
    model.authenticateFunctionByUniquekey = (req, res, next) => {
        gFunctionAuthenticator({appid: defaults.gAppID}).authenticateFunctionByUniqueKey({function: `@${req.params.func}`, uniquekey: req.session.gLogin.logged_user}, function(error, document) {
            if(error) res.send(document)
            else next()
        })
    }

    return model
}
